/*===============================================================*
 *   Version 1.2        BKRESMSG.C                               *
 *---------------------------------------------------------------*
 *     VERSION  DATE	 BY      CHANGE/COMMENTS                 *
 *---------------------------------------------------------------*
 *	1.3     12/17/86 lt     Backup and restore messages are  *
 *				located here.			 *
 *	1.2	3/05/86  mei    Message adjustment.		 *
 *  	1.1 	2/21/86  mei	More messages for error handling,*
 *				added header.			 *
 *  	1.0 	7/7/85   bw 		Initial version          * 
 *===============================================================*/

/* Message module for BACKUP utility. */

#include	"portab.h"
#include	"concur.h"

/* Common messages for BACKUP and RESTORE */

BYTE	brm01[] = "BACKUP";
BYTE	brm02[] = "RESTORE";
BYTE	brm03[] = "\n\rInsert backup diskette #% in drive %";
BYTE	brm04[] = "\n\rPress any key when you are ready ...\n\r";

/* BACKUP messages */

BYTE	bkmodule[] = "\n\rBACKUP";	
BYTE	bkm02[] = "\r\nWarning! All files on diskette #% will be erased.";
BYTE	bkm04[] = "\n\r*** Backing up files to diskette % ***";

/* RESTORE messages */

BYTE	rsmodule[] = "RESTORE";
BYTE	rsm03[] = "\n\r*** Restoring files from diskette % ***";
BYTE	rsm04[] = "\n\r*** Files were backed up % ***\n\r";
BYTE	rsm06[] = "\n\rWarning! Diskette is out of sequence";
BYTE	rsm07[] = "\n\rReplace the diskette or continue";
BYTE	rsm08[] = "\n\rRestore file sequence error";
BYTE	rsm10[] = "\n\r\n\rWarning! File % \n\ris a read only file ";
BYTE	rsm11[] = "\n\rReplace the file (Y/N)? ";
BYTE	rsm12[] = "\n\r\n\rWarning! File % \n\rwas changed after it was \
backed up";

/* Common error messages for BACKUP and RESTORE */

BYTE	bre01[] = "\n\r%0 expected two drive specifications.";
BYTE	bre02[] = "\n\rInvalid file specification.";
BYTE	bre03[] = "\n\rSource and target drives are the same.";
BYTE	bre04[] = "\r\nDiskette in drive %3 is not a backup diskette.";
BYTE	bre05[] = "\n\rUnknown disk media in drive %.\n\r";
BYTE	bre06[] = "\n\rDrive % is empty. Please insert a disk.";

/* BACKUP error messages */
BYTE	bke01[] = "\n\rThe second parameter has to be a device name only.";

BYTE	*bke03[] = {
"\r\n%0: Insufficient disk space.",
"\n\r%0: There is no room on %1.",
""
};

BYTE	bke06[] = "\n\rA - Adds files to the backup disk.\
\n\rM - Only backs up files modified since the last backup.\
\n\rS - Backs up the current directory as well as all the subdirectories.\
\n\rD:mm/dd/yy - Only backs up files modified on or after the specified date.";

BYTE	bke07[] = "\n\n\rReplace bad disk #% in drive %.";
BYTE	bke08[] = "\n\rDiskette #% will be rewritten.\n\r";

/* RESTORE error messages */

BYTE	rse01[] = "\n\rP - Prompts you for files have changes since the \
last back-up or \n\r    files marked read-only. \
\n\rS - Restores the current directory as well as all the subdirectories";
BYTE	rse02[] = "\n\rThe first paremeter has to be a device name only";


